<template>
	<div class="flex flex-col" :class="[fromSubscription ? '' : 'px-4 lg:px-4']">
		<div class="flex justify-between w-full items-center">
			<p class="font-primary-font-bold text-base text-black">Promo code</p>
			<button
				:aria-label="showPromoCode ? 'Close' : 'Add Promo Code'"
				class="focus:outline-none focus:ring-1 focus:ring-black"
				@click="closePromoCode($event)"
				@keypress.enter="closePromoCode($event)"
			>
				<span v-if="!showPromoCode" id="add-promo" class="icon-plus text-xs cursor-pointer focus:p-1"></span>
				<span
					v-if="showPromoCode"
					:id="success ? 'promo_code_close' : 'promo_code_minus'"
					:class="
						success
							? 'icon-close text-lg cursor-pointer focus:outline-none focus:ring-1 focus:ring-black'
							: 'icon-minus text-xs cursor-pointer focus:p-1 focus:outline-none focus:ring-1 focus:ring-black'
					"
				></span>
			</button>
		</div>
		<div v-if="showPromoCode">
			<MkInput
				id="promocode_input"
				ref="promocode_input"
				variant="outline"
				:read-only="success"
				label="Enter promo code -1 per order"
				:value="promoCode"
				maxlength="16"
				@input="getPromoCodeValue($event)"
				@keydown.enter="applyPromoCode"
			/>
			<p
				v-if="validationMsg.length > 0"
				role="alert"
				:class="[
					success == true
						? 'mt-1 rounded-md py-2 text-secondary  text-base md:text-sm  font-primary-font-light'
						: 'mt-1 rounded-md text-error-20  py-2 text-base md:text-sm font-primary-font-light',
				]"
			>
				{{ validationMsg }}
			</p>
			<MkPrimaryButton
				v-if="!success"
				:disabled="!enableApplyCode"
				:loading="promoLoading"
				button-title="Apply"
				class="flex justify-center items-center mt-4 md:mt-6 lg:mt-8"
				@click="applyPromoCode"
			/>
			<MkPrimaryButton
				v-else
				:loading="promoLoading"
				button-title="Remove"
				class="flex justify-center items-center mt-4 md:mt-6 lg:mt-8"
				@click="displayPromoCode()"
			/>
		</div>
	</div>
</template>
<script>
import { mapState } from 'vuex';
import MkInput from '~/components/D2C/atoms/MkInput.vue';
import MkPrimaryButton from '~/components/D2C/atoms/MkPrimaryButton.vue';
export default {
	name: 'MkOrderPromo',
	components: {
		MkInput,
		MkPrimaryButton,
	},
	props: {
		accountClass: {
			type: Boolean,
			default: true,
		},
		fromSubscription: {
			type: Boolean,
			default: false,
		},
		subscriptionCartID: {
			type: String,
			default: '',
		},
	},
	data() {
		return {
			showPromoCode: false,
			promoCode: '',
			enableApplyCode: false,
			validationMsg: '',
			errors: false,
			success: false,
			promoCodeFlag: '',
			promoLoading: false,
		};
	},
	computed: {
		...mapState('CART_STORE', [
			'CART_ID',
			'LINE_ITEMS',
			'TOTAL_PRICE',
			'SUB_TOTAL_PRICE',
			'DISCOUNT_PRICE',
			'PROMOCODE',
		]),
		cartId() {
			if (this.fromSubscription) {
				return this.subscriptionCartID;
			} else {
				return this.CART_ID;
			}
		},
	},
	watch: {
		PROMOCODE: {
			deep: true,
			handler() {
				this.checkPromo();
			},
		},
	},
	mounted() {
		this.checkPromo();
	},
	methods: {
		getPromoCodeValue(val) {
			this.validationMsg = '';
			this.success = false;
			this.errors = false;
			if (val === '') {
				this.enableApplyCode = false;
			} else {
				this.enableApplyCode = true;
			}
			this.promoCode = val;
		},
		async displayPromoCode() {
			if (this.promoCode !== '') {
				this.validationMsg = '';
				if (this.promoCodeFlag === this.promoCode) {
					this.promoLoading = true;
					const result = await this.$repositories.checkout.removePromoCode(this.promoCode, this.cartId);
					if (result.status === 200 && result.data) {
						this.promoCode = '';
						if (this.cartId && !this.fromSubscription) {
							await this.$store.dispatch('CART_STORE/FETCH_CART', {
								cartID: this.cartId,
							});
						} else {
							await this.$store.dispatch('CART_STORE/FETCH_CART_SUBSCRIPTION', {
								cartID: this.cartId,
							});
							this.$emit('promo-api-call');
						}
					} else {
						// Handle error here
					}
					this.promoLoading = false;
					this.validationMsg = 'Your coupon was successfully removed.';
				}
				this.enableApplyCode = false;
				this.promoCode = '';
				this.success = false;
				this.errors = true;
			}
		},
		closePromoCode(e) {
			e.preventDefault();
			this.showPromoCode = !this.showPromoCode;
			this.validationMsg = '';
			this.errors = false;
		},
		async applyPromoCode() {
			try {
				this.promoLoading = true;
				const inputVal = this.promoCode;
				const result = await this.$repositories.checkout.applyPromoCode(inputVal, this.cartId).catch((e) => {
					this.success = false;
					this.errors = true;
					this.validationMsg = 'Invalid code. Please verify and try again.';
					this.tealiumPromoCode('coupon_code_failed');
				});
				if (result.status === 200 && result.data) {
					const { data } = result;
					if (data.statusCode === 400 || (data.custom && data.custom.fields && data.custom.fields.discountMessage)) {
						this.success = false;
						this.errors = true;
						this.validationMsg = data.errorMessage || data.message || data.custom.fields.discountMessage;
						this.tealiumPromoCode('coupon_code_failed');
					} else {
						this.success = false;
						this.errors = false;
						if (this.cartId && !this.fromSubscription) {
							await this.$store.dispatch('CART_STORE/FETCH_CART', {
								cartID: this.cartId,
							});
						} else {
							await this.$store.dispatch('CART_STORE/FETCH_CART_SUBSCRIPTION', {
								cartID: this.cartId,
							});
							this.$emit('promo-api-call');
						}
						if (data.discountCodes !== undefined) {
							this.success = true;
							this.promoCodeFlag = inputVal;
							this.validationMsg = 'Your coupon was successfully applied.';
							this.enableApplyCode = false;
						} else {
							this.success = false;
							this.errors = true;
							this.validationMsg = 'Invalid code. Please verify and try again.';
							this.tealiumPromoCode('coupon_code_failed');
						}
					}
					this.promoLoading = false;
				} else {
					// Handle error here
				}
			} catch (exp) {
				this.promoLoading = false;
			}
		},
		tealiumPromoCode(tealiumEvent) {
			const customerDetails = this.$store.state.USER_STORE.CUSTOMER_DETAILS_D2C_TEALIUM;
			const tealiumPayload = {
				event_label: this.promoCode || '',
				event_value: 'Apply',
				page_type: 'checkout page',
				event_category: 'Coupon Code Failed',
				event_action: 'Coupon Code failed to apply',
				cart_id: this.cartId,
				cart_product_id: [...new Set(this.LINE_ITEMS.map((product) => product.productId))],
				cart_product_quantity: [...new Set(this.LINE_ITEMS.map((product) => product.quantity.toFixed(0) || '1'))],
				cart_product_sku: [...new Set(this.LINE_ITEMS.map((product) => product.variant.sku))],
				cart_total_items: this.LINE_ITEMS.length.toFixed(0),
				cart_total_value: this.$options.filters.centsToDollars(this.SUB_TOTAL_PRICE),
				cart_discount: [this.$options.filters.centsToDollars(this.DISCOUNT_PRICE)],
				...customerDetails,
			};
			const listPrice = [];
			const productListPrice = [...new Set(this.LINE_ITEMS.map((product) => product.price))];
			productListPrice.forEach((el) => {
				if (el.value) {
					listPrice.push(this.$options.filters.centsToDollars(el.value.centAmount));
				}
			});
			tealiumPayload.cart_product_price = listPrice;
			this.$root.$telium.setTealiumPayload(tealiumEvent, tealiumPayload);
		},
		checkPromo() {
			if (this.PROMOCODE) {
				this.showPromoCode = true;
				this.promoCode = this.PROMOCODE;
				this.success = true;
				this.promoCodeFlag = this.promoCode;
			} else {
				this.showPromoCode = false;
				this.promoCode = '';
				this.success = false;
				this.promoCodeFlag = '';
			}
		},
	},
};
</script>
